# ftpd.rs - Windows FTP Plugin Written By Narrow (nss@privacyx.com)

push @plugins, 'win_ftpd';

sub win_ftpd {
if($debug) { print "Checking for ftpd ...\n"; }
$ftpd_host = shift;
$remote = $ftpd_host; $port = 21;
$iaddr = inet_aton($remote) || return 0;
$paddr = sockaddr_in($port, $iaddr);
$proto = getprotobyname('tcp');
socket(ftpd, PF_INET, SOCK_STREAM, $proto) || return 0;
connect(ftpd, $paddr) || return 0;
while(<ftpd>) {
chomp;
    if(/serv-u/i && /2.3/) {
	print "[$ftpd_host] - [Serv-U 2.3]\n";
	print LOG "[$ftpd_host] - [Serv-U 2.3]\n";
	close ftpd;
    	return;
    }
    if(/serv-u/i && /2.2/) {
	print "[$ftpd_host] - [Serv-U 2.2]\n";
	print LOG "[$ftpd_host] - [Serv-U 2.2]\n";
	close ftpd;
    	return;
    }
    if(/serv-u/i && /2.0c/) {
	print "[$ftpd_host] - [Serv-U 2.0c]\n";
	print LOG "[$ftpd_host] - [Serv-U 2.0c]\n";
	close ftpd;
    	return;
    }
    if(/serv-u/i && /2.5([a,b])/) {
	print "[$ftpd_host] - [Serv-U 2.5$1]\n";
	print LOG "[$ftpd_host] - [Serv-U 2.5$1]\n";
	close ftpd;
	return;
    }
    if(/serv-u/i && /2.5/) {
	print "[$ftpd_host] - [Serv-U 2.5]\n";
	print LOG "[$ftpd_host] - [Serv-U 2.5]\n";
	close ftpd;
    	return;
    }
    if(/war/i && /1.65/) {
	print "[$ftpd_host] - [War FTPD 1.65]\n";
	print LOG "[$ftpd_host] - [War FTPD 1.65]\n";
	close ftpd;
    	return;
    }
    if(/war/i && /1.70/) {
	print "[$ftpd_host] - [War FTPD 1.70]\n";
	print LOG "[$ftpd_host] - [War FTPD 1.70]\n";
	close $ftpd;
	return;
    }
    if(/expressfs/i && /2.([0-9])/) {
	print "[$ftpd_host] - [ExpressFS 2.$1]\n";
	print LOG "[$ftpd_host] - [ExpressFS 2.$1]\n";
	close ftpd;
    	return;
    }
    if(/wftpd/i && /2.([34-40])/) {
	print "[$ftpd_host] - [WFTPD 2.$1]\n";
	print LOG "[$ftpd_host] - [WFTPD 2.$1]\n";
	close ftpd;
    	return;
    }
    if(/tiny/i && /0.51/) {
	print "[$ftpd_host] - [Tiny FTPd 0.51]\n";
	print LOG "[$ftpd_host] - [Tiny FTPd 0.51]\n";
	close ftpd;
	return;
    }
    if(/bisonware/i && /3.5/) {
	print "[$ftpd_host] - [BisonWare FTP Server 3.5]\n";
	print LOG "[$ftpd_host] - [BisonWare FTP Server 3.5]\n";
	close ftpd;
	return;
    }
    if(/nextftp/i && /1.82/) {
	print "[$ftpd_host] - [NextFTP v1.82]\n";
	print LOG "[$ftpd_host] - [NextFTP v1.82]\n";
	close ftpd;
	return;
    }
    if(/broker ftp/i && /3.0/) {
	print "[$ftpd_host] - [Broker FTP Server 3.0]\n";
	print LOG "[$ftpd_host] - [Broker FTP Server 3.0]\n";
	close ftpd;
	return;
    }
    if(/vftpd/i && /1.23/) {
	print "[$ftpd_host] - [VFTPD v1.23]\n";
	print LOG "[$ftpd_host] - [VFTPD v1.23]\n";
	close ftpd;
	return;
    }
    if(/g6 ftp server/i && /2.0/) {
	print "[$ftpd_host] - [G6 FTP Server 2.0]\n";
	print LOG "[$ftpd_host] - [G6 FTP Server 2.0]\n";
	close ftpd;
	return;
    }
    if(/microsoft ftp server/i && /ersion ([3-4]).0/) {
	print "[$ftpd_host] - [Microsoft FTP Server $1.0]\n";
	print LOG "[$ftpd_host] - [Microsoft FTP Server $1.0]\n";
	close ftpd;
	return;
    }
    if(/ws_ftp server/i && /1.0.2.eval/i) {
	print "[$ftpd_host] - [WS_FTP Sercer 1.0.2.EVAL]\n";
	print LOG "[$ftpd_host] - [WS_FTP Sercer 1.0.2.EVAL]\n";
	close ftpd;
	return;
    }
close ftpd;
 }
}
print;