# mail.rs - Windows Mail Plugin Written By Narrow (nss@privacyx.com)

push @plugins, 'win_mail';

sub win_mail {
if($debug) { print "Checking for mail ...\n"; }
$mail_host = shift;
$remote = $mail_host; $port = 25;
$iaddr = inet_aton($remote) || return 0;
$paddr = sockaddr_in($port, $iaddr);
$proto = getprotobyname('tcp');
socket(mail, PF_INET, SOCK_STREAM, $proto) || return 0;
connect(mail, $paddr) || return 0;
while(<mail>) { chomp;
    if(/microsoft exchange/i && /5.0.1457.7/) {
	print "[$mail_host] - [MS Exchange 5.0]\n";
	print LOG "[$mail_host] - [MS Exchange 5.0]\n";
	close mail;
	return;
    }
    if(/slmail/i && /v2.6/) {
	print "[$mail_host] - [SLMail v2.6]\n";
	print LOG "[$mail_host] - [SLMail v2.6]\n";
	close mail;
	return;
    }
    if(/slmail/i && /3.([1-2])/) {
	print "[$mail_host] - [SLMail v3.$1]\n";
	print LOG "[$mail_host] - [SLMail v3.$1]\n";
	close mail;
	return;
    }
    if(/avirt mail/i) {
	print "[$mail_host] - [aVirt Mail]\n";
	print LOG "[$mail_host] - [aVirt Mail]\n";
	close mail;
	return;
    }
    if(/cmail server/i && /version/i && /2.([3-4])/) {
	print "[$mail_host] - [CMail Server 2.$1]\n";
	print LOG "[$mail_host] - [CMail Server 2.$1]\n";
	close mail;
	return;
    }
    if(/netscape messaging server/i && /3.62/) {
	print "[$mail_host] - [Netscape Messaging Server 3.62]\n";
	print LOG "[$mail_host] - [Netscape Messaging Server 3.62]\n";
	close mail;
	return;
    }
    if(/interscan viruswall nt/i && /3.23/) {
	print "[$mail_host] - [InterScan VirusWall NT ESMTP 3.23]\n";
	print LOG "[$mail_host] - [InterScan VirusWall NT ESMTP 3.23]\n";
	close mail;
	return;
    }
    if(/smail/i && /\-3.2/) {
	print "[$mail_host] - [SMail 3.2]\n";
	print LOG "[$mail_host] - [SMail 3.2]\n";
	close mail;
	return;
    }
    if(/internet anywhere mail server/i && /2.3.1/) {
	print "[$mail_host] - [Internet Anywhere Mail Server 2.3.1]\n";
	print LOG "[$mail_host] - [Internet Anywhere Mail Server 2.3.1]\n";
	close mail;
	return;
    }
    if(/skyfull mail server/i && /1.1.4/) {
	print "[$mail_host] - [Skyfull Mail Server 1.1.4]\n";
	print LOG "[$mail_host] - [Skyfull Mail Server 1.1.4]\n";
	close mail;
	return;
    }
    if(/zetamail/i && /2.1/) {
	print "[$mail_host] - [ZetaMail 2.1 (SMTP)]\n";
	print LOG "[$mail_host] - [ZetaMail 2.1 (SMTP)]\n";
	close mail;
	return;
    }
    if(/netcplus smartserver3/i) {
	print "[$mail_host] - [NetcPlus SmartServer3]\n";
	print LOG "[$mail_host] - [NetcPlus SmartServer3]\n";
	close mail;
	return;
    }
    if(/zom\-mail/i && /1.09/) {
	print "[$mail_host] - [Zom-Mail 1.09]\n";
	print LOG "[$mail_host] - [Zom-Mail 1.09]\n";
	close mail;
	return;
    }
    if(/csm mail/i && /ersion 2000\-01A/) {
	print "[$mail_host] - [CSM Mail 2000-01A]\n";
	print LOG "[$mail_host] - [CSM Mail 2000-01A]\n";
	close mail;
	return;
    }
    if(/csm mail/i && /ersion 1999\-07([M,I,H,G,F,b])/) {
	print "[$mail_host] - [CSM Mail 1999-07$1]\n";
	print LOG "[$mail_host] - [CSM Mail 1999-07$1]\n";
	close mail;
	return;
    }
close mail;
 }
}
print;